Index: drivers/video/l4fb.c
===================================================================
--- drivers/video/l4fb.c	(revision 69)
+++ drivers/video/l4fb.c	(working copy)
@@ -60,6 +60,7 @@
 static unsigned int nograb;
 static l4dm_dataspace_t fbds;
 static int disable, use_con, use_dope;
+static int console_visible = 1, window_visible = 0;
 
 static enum mode mode = MODE_NONE;
 
@@ -698,6 +699,14 @@
 	while (1) {
 		if (l4fb_refresh_enabled)
 			dope_cmd(dope_app_id, "l4lxvscr.refresh()");
+        if (console_visible && !window_visible) {
+            dope_cmd(dope_app_id, "l4lxwin.open()");
+            window_visible = 1;
+        }
+        if (window_visible && !console_visible) {
+            dope_cmd(dope_app_id, "l4lxwin.close()");
+            window_visible = 0;
+        }
 		l4lx_sleep(l4fb_refresh_sleep);
 	}
 }
@@ -722,7 +731,6 @@
 	if (!nograb)
 		dope_cmd(dope_app_id, "l4lxvscr.set(-grabmouse yes)");
 	dope_cmdf(dope_app_id,"l4lxwin.set(-x %d -y %d -workw %d -workh %d -background off -content l4lxvscr)", dope_xpos, dope_ypos, xres, yres);
-	dope_cmd(dope_app_id, "l4lxwin.open()");
 
 	/* hard-coded since DOpE doesn't support anything else right now */
 	var->bits_per_pixel = 16; /* also 16 for 15bpp modi */
@@ -949,19 +957,19 @@
 MODULE_LICENSE("GPL");
 
 
-module_param(refreshsleep, int, 0);
+module_param(refreshsleep, int, 0444);
 MODULE_PARM_DESC(refreshsleep, "Sleep between frame buffer refreshs in ms");
 module_param(xpos, int, 0);
 MODULE_PARM_DESC(xpos, "X position of the DOpE window");
 module_param(ypos, int, 0);
 MODULE_PARM_DESC(ypos, "Y position of the DOpE window");
-module_param_string(title, window_title, sizeof(window_title), 0);
+module_param_string(title, window_title, sizeof(window_title), 0444);
 MODULE_PARM_DESC(title, "Title of the DOpE window");
-module_param(xres, uint, 0);
+module_param(xres, uint, 0444);
 MODULE_PARM_DESC(xres, "Width of DOpE window in pixels");
-module_param(yres, uint, 0);
+module_param(yres, uint, 0444);
 MODULE_PARM_DESC(yres, "Height of DOpE window in pixels");
-module_param(depth, uint, 0);
+module_param(depth, uint, 0444);
 MODULE_PARM_DESC(depth, "Color depth");
 module_param(nograb, uint, 0);
 MODULE_PARM_DESC(nograb, "Do not grab window focus with mouse (DOpE only)");
@@ -971,3 +979,5 @@
 MODULE_PARM_DESC(use_dope, "Use DOpE only");
 module_param(use_con, bool, 0);
 MODULE_PARM_DESC(use_con, "Use l4con only");
+module_param(console_visible, bool, 0644);
+MODULE_PARM_DESC(console_visible, "Tells whether console should be visible");
